<template>
  <v-autocomplete
    label="Select Product"
    v-model="selected_id"
    :items="products"
    item-text="name"
    item-value="id"
  >
    <template slot="item" slot-scope="data">
      <v-list-tile-content>
        <product-list-item :id="data.item.id" class="autocomplete-product-item"/>
      </v-list-tile-content>
    </template>
  </v-autocomplete>
</template>

<script>
import gql from "graphql-tag";
import ProductListItem from "@/components/list-items/ProductListItem";
import CreateProductDialog from "@/components/dialogs/CreateProductDialog";
import Fuse from "fuse.js";

export default {
  components: { ProductListItem, CreateProductDialog },
  props: {
    value: String
  },
  data() {
    return {
      dialog: false,
      selected: null
    };
  },
  computed: {
    selected_id: {
      get() {
        return this.value;
      },
      set(v) {
        this.$emit("input", v);
      }
    }
  },
  apollo: {
    selected: {
      query: gql`
        query($id: ID!) {
          selected: product(id: $id) {
            id
          }
        }
      `,
      skip() {
        return !this.selected_id;
      },
      variables() {
        return {
          id: this.selected_id
        };
      }
    },
    products: gql`
      query {
        products: listProducts {
          id
          name
        }
      }
    `
  },
  open() {
    this.dialog = true;
  }
};
</script>

<style lang="scss">
.autocomplete-product-item {
  width: 100%;
}
</style>
